Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 523048 - sys-apps/portage-2.2.13: slot operator conflict due to unsatisfied REQUIRED_USE, observed for x11-base/xorg-server with USE="glamor -uxa" and unsatisfied REQUIRED_USE="glamor? ( uxa )" in x11-drivers/xf86-video-intel
Summary: sys-apps/portage-2.2.13: slot operator conflict due to unsatisfied REQUIRED_U...
Status: RESOLVED FIXED
Alias: None
Product: Portage Development
Classification: Unclassified
Component: Core - Dependencies (show other bugs)
Hardware: All All
: Normal normal (vote)
Assignee: Portage team
URL:
Whiteboard:
Keywords: InVCS
Depends on:
Blocks: 155723
  Show dependency tree
 
Reported: 2014-09-17 16:23 UTC by Arfrever Frehtes Taifersar Arahesis
Modified: 2014-12-04 15:01 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
_backtrack_depgraph: fix bug #523048 (_backtrack_depgraph-fix-bug-523048.patch,4.73 KB, patch)
2014-09-18 18:39 UTC, Zac Medico
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Arfrever Frehtes Taifersar Arahesis 2014-09-17 16:23:35 UTC
I use Portage trunk (2.2.13_p1; 1feee4c3627bcf33565bde1f1dc906c1326a76ba).

$ USE="-glamor" emerge -ptv x11-base/xorg-server

These are the packages that would be merged, in reverse order:

Calculating dependencies... done!
[ebuild  rR    ] x11-drivers/xf86-video-intel-2.99.916::gentoo  USE="dri sna udev xvmc -debug -glamor -uxa" 0 KiB
[ebuild  rR    ] x11-drivers/xf86-video-fbdev-0.4.4::gentoo  0 KiB
[ebuild  rR    ] x11-drivers/xf86-input-evdev-2.8.4::gentoo  0 KiB
[ebuild  rR    ] x11-drivers/xf86-video-vesa-2.3.3::gentoo  0 KiB
[ebuild  r  U  ]  x11-base/xorg-server-1.16.0.901:0/1.16.0.901::gentoo [1.16.0:0/1.16.0::gentoo] USE="ipv6 nptl suid udev unwind xorg xvfb -dmx -doc -glamor -kdrive -minimal -selinux -static-libs -systemd -tslib -wayland -xnest" 5666 KiB

Total: 5 packages (1 upgrade, 4 reinstalls), Size of downloads: 5666 KiB

The following packages are causing rebuilds:

  (x11-base/xorg-server-1.16.0.901:0/1.16.0.901::gentoo, ebuild scheduled for merge) causes rebuilds for:
    (x11-drivers/xf86-video-fbdev-0.4.4:0/0::gentoo, ebuild scheduled for merge)
    (x11-drivers/xf86-video-intel-2.99.916:0/0::gentoo, ebuild scheduled for merge)
    (x11-drivers/xf86-video-vesa-2.3.3:0/0::gentoo, ebuild scheduled for merge)
    (x11-drivers/xf86-input-evdev-2.8.4:0/0::gentoo, ebuild scheduled for merge)

$ USE="glamor" emerge -ptv x11-base/xorg-server

These are the packages that would be merged, in reverse order:

Calculating dependencies -

!!! Problem resolving dependencies for x11-drivers/xf86-video-intel:0 from @__auto_slot_operator_replace_installed__
... done!
[ebuild     U  ] x11-base/xorg-server-1.16.0.901:0/1.16.0.901::gentoo [1.16.0:0/1.16.0::gentoo] USE="glamor* ipv6 nptl suid udev unwind xorg xvfb -dmx -doc -kdrive -minimal -selinux -static-libs -systemd -tslib -wayland -xnest" 5666 KiB
[ebuild  N     ]  media-libs/libepoxy-1.2::gentoo  USE="{-test}" ABI_MIPS="(-n32) (-n64) (-o32)" ABI_PPC="(-32) (-64)" ABI_S390="(-32) (-64)" ABI_X86="(64) -32 (-x32)" 261 KiB

Total: 2 packages (1 upgrade, 1 new), Size of downloads: 5927 KiB

!!! Multiple package instances within a single package slot have been pulled
!!! into the dependency graph, resulting in a slot conflict:

x11-base/xorg-server:0

  (x11-base/xorg-server-1.16.0.901:0/1.16.0.901::gentoo, ebuild scheduled for merge) pulled in by
    x11-base/xorg-server (Argument)

  (x11-base/xorg-server-1.16.0:0/1.16.0::gentoo, installed) pulled in by
    x11-base/xorg-server:0/1.16.0= required by (x11-drivers/xf86-video-vesa-2.3.3:0/0::gentoo, installed)
                        ^^^^^^^^^^                                                                                                           
    (and 3 more with the same problem)


It may be possible to solve this problem by using package.mask to
prevent one of those packages from being selected. However, it is also
possible that conflicting dependencies exist such that they are
impossible to satisfy simultaneously.  If such a conflict exists in
the dependencies of two different packages, then those packages can
not be installed simultaneously. You may want to try a larger value of
the --backtrack option, such as --backtrack=30, in order to see if
that will solve this conflict automatically.

For more information, see MASKED PACKAGES section in the emerge man
page or refer to the Gentoo Handbook.
Comment 1 Arfrever Frehtes Taifersar Arahesis 2014-09-17 17:34:53 UTC
Problem does not occur with USE="glamor uxa".
`USE="glamor -uxa" emerge -ptv x11-base/xorg-server` should print error message similar to error message in below command:

$ USE="glamor -uxa" emerge -ptv x11-drivers/xf86-video-intel

These are the packages that would be merged, in reverse order:

Calculating dependencies |

!!! Problem resolving dependencies for x11-drivers/xf86-video-intel
... done!

!!! The ebuild selected to satisfy "x11-drivers/xf86-video-intel" has unmet requirements.
- x11-drivers/xf86-video-intel-2.99.916::gentoo USE="dri glamor sna udev xvmc -debug -uxa" ABI_X86="64" ELIBC="glibc" KERNEL="linux" USERLAND="GNU"

  The following REQUIRED_USE flag constraints are unsatisfied:
    glamor? ( uxa )

  The above constraints are a subset of the following complete expression:
    any-of ( sna uxa ) glamor? ( uxa )
Comment 2 Zac Medico gentoo-dev 2014-09-18 18:39:05 UTC
Created attachment 385060 [details, diff]
_backtrack_depgraph: fix bug #523048

This fixes _backtrack_depgraph to immediately report necessary REQUIRED_USE changes instead of discarding the graph. This is accomplished by replacing the depgraph.success_without_autounmask method with a new need_config_change method that accounts for both autounmask and REQUIRED_USE changes.

I'll be maintaining this patch in the following branch:

	https://github.com/zmedico/portage/tree/bug_523048
Comment 3 Arfrever Frehtes Taifersar Arahesis 2014-09-18 20:38:31 UTC
This patch works, but some Portage internals are leaking in output:

!!! Problem resolving dependencies for x11-drivers/xf86-video-intel:0 from @__auto_slot_operator_replace_installed__
Comment 4 Zac Medico gentoo-dev 2014-09-18 20:42:58 UTC
(In reply to Arfrever Frehtes Taifersar Arahesis from comment #3)
> This patch works, but some Portage internals are leaking in output:

Great, thanks for testing.

> !!! Problem resolving dependencies for x11-drivers/xf86-video-intel:0 from
> @__auto_slot_operator_replace_installed__

I'm pretty sure those internal sets get displayed to the user in lots of cases already, so I think we should simply ignore that for now.
Comment 6 Brian Dolbec gentoo-dev 2014-12-04 05:42:42 UTC
This is in the portage-2.2.15 release.
Comment 7 Zac Medico gentoo-dev 2014-12-04 15:01:34 UTC
(In reply to Brian Dolbec from comment #6)
> This is in the portage-2.2.15 release.

It should be in 2.2.14 too:

$ git describe --tags beecd610f21497609679a08f867fd88090c71fb7
v2.2.13-4-gbeecd61